#include "buttonnode.h"
#include "buttonshape.h"
#include "backgroundnode.h"

#include <iostream>

#include "scene/scenetree.h"
#include "input.h"
#include "sparrowshell/sparrowshell.h"
#include "mesh.h"
#include "phongmaterial.h"

ButtonNode::ButtonNode(glm::vec2 position,ButtonShape* shape):
    m_position(position),m_shape(shape)
{
    addChild(m_shape->getBackGround());
}

MeshNode* ButtonNode::getBackGround()
{
    return m_shape->getBackGround();
}

void ButtonNode::update()
{
    Input* input = getEngine().getInput();
    sf::Vector2i v = input->getPosition();
    glm::vec2 pos = glm::vec2(v.x,v.y);
    PhongMaterial* mat = (PhongMaterial*) m_shape->getBackGround()->getGeometryNode()->mesh->getMaterial();
    if (m_shape->hover(pos)){
        mat->diffuse=glm::vec3(0.2,0.6,0.6);
    }else{
        mat->diffuse=glm::vec3(0.6,0.2,0.6);
    }

    for (auto action : input->getActions())
    {
        if (action == m_action){
            if (m_shape->hover(pos))
                m_callback->exec();
        }
    }
}
