#include "buttonshape.h"
#include "glm/common.hpp"
#include "scene/gui/backgroundnode.h"

RectangleButtonShape::RectangleButtonShape(glm::vec2 position, glm::vec2 dimension):ButtonShape(position),m_dimension(dimension)
{
    m_background = new BackGroundNode(position,dimension,glm::vec3(0,0,0),1,0);
}

bool RectangleButtonShape::hover(glm::vec2 mouse_position){
    glm::vec2 pos = getPosition();
    return (mouse_position.x >= pos.x && mouse_position.x < pos.x + m_dimension.x)
            && (mouse_position.y >= pos.y && mouse_position.y < pos.y + m_dimension.y);
}

MeshNode* RectangleButtonShape::getBackGround(){
    return m_background;
}
